<template>
  <div class="q-px-lg">
    <div class="row items-center justify-between">
      <h4 class="text-h4 text-weight-medium">{{ info.name }}</h4>
      <h4 class="text-h4">
        <q-btn
          @click="editContent"
          class="float-right"
          outline
          color="primary"
          label="Modifica"
          v-if="!isActive"
        />
      </h4>
    </div>

    <div v-if="content === ''">You have no content here!</div>

    <q-editor
      v-if="isActive"
      v-model="content"
      toolbar-bg="primary"
      toolbar-text-color="white"
      toolbar-toggle-color="secondary"
      content-class="bg-grey-2"
      min-height="5rem"
    />
    <q-card v-else flat bordered>
      <q-card-section v-html="content" />
    </q-card>

    <div class="buttons" v-show="isActive">
      <q-btn @click="saveContent" class="on-right self-end" color="primary" label="salveaza" />

      <q-btn
        @click="cancelContent"
        class="q-ml-xs float-right"
        outline
        color="primary"
        label="Renunta"
      />
    </div>
  </div>
</template>

<script>
export default {
  name: "edit-panel",
  props: {
    info: {
      type: Object,
      required: true,
    },
  },
  mounted() {
    this.content = this.info.value;
    this.contentTemp = this.info.value;
  },
  data() {
    return {
      content: "",
      contentTemp: "",
      isActive: false,
    };
  },
  methods: {
    editContent() {
      this.contentTemp = this.content;
      this.isActive = true;
    },
    saveContent() {
      //request to db
      if (this.content) {
        this.$axios
          .put("/api/preferences", {
            name: this.info.name,
            value: this.content,
          })
          .then((response) => {
            this.$q.notify({
              message: response.data.message,
              color: "positive",
            });
            this.$store.dispatch("adminData/loadAdminPreferences");
            this.isActive = false;
          })
          .catch((error) => {
            this.$q.notify({
              color: "negative",

              message: error.response.data.message,
              icon: "report_problem",
            });
          });
      } else
        this.$q.notify({
          color: "negative",

          message: "Campul nu poate fi gol",
          icon: "report_problem",
        });
    },
    cancelContent() {
      this.content = this.contentTemp;
      this.isActive = false;
    },
  },
};
</script>

<style lang="scss" scoped>
h4 {
  margin: 0;
  margin-top: 45px;
  margin-bottom: 10px;
}

.q-editor {
  max-height: 600px;
  overflow-y: scroll;
}
.q-btn {
  margin: 2% 0;
}
.buttons {
  display: flex;
  align-items: center;
  flex-direction: row;
  justify-content: space-evenly;
}
</style>
